package com.dsic.gj_erp.controller.jhgk;

import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.YdjhImportNew;
import com.dsic.gj_erp.listeners.ExcelYdjhImportNewListener;
import com.dsic.gj_erp.service.jhgk.impl.YdjhImportNewService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;


@RestController
@RequestMapping("ydjhImportNew")
@AllArgsConstructor
public class YdjhImportNewController {

    private final YdjhImportNewService ydjhImportNewService;

    @GetMapping("listByFileName")
    public ResultBean<?> listByFileName(String fileName,String zt) {
        return new ResultBean<>(ydjhImportNewService.listByFileName(fileName,zt));
    }

    @RequestMapping("/getFileNameList")
    public ResultBean<?> getFileNameList(){
        return new ResultBean<>(ydjhImportNewService.getFileNameList());
    }

    @RequestMapping("/ydjhImportNew")
    @AuthFunction
    public ResultBean ydjhImportNew(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws IOException {
        ExcelYdjhImportNewListener objectListener = new ExcelYdjhImportNewListener();
        EasyExcel.read(file.getInputStream(), YdjhImportNew.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<YdjhImportNew> objList = objectListener.getObjectList();

        String fileName = file.getOriginalFilename();
        fileName= StrUtil.removeSuffix(fileName, ".xls");
        fileName=StrUtil.removeSuffix(fileName, ".xlsx");
        ydjhImportNewService.handler(objList, fileName, req);
        return new ResultBean(fileName);
    }

    @GetMapping("/tj")
    public ResultBean<?> tj(String fileName) {
        ydjhImportNewService.tj(fileName);
        return new ResultBean<>();
    }

    @GetMapping("/sh")
    @AuthFunction
    public ResultBean<?> sh(String fileName,HttpServletRequest request) {
        String yhms = (String) request.getAttribute("yhms");
        ydjhImportNewService.sh(fileName,yhms);
        return new ResultBean<>();
    }
}
