package com.dsic.gj_erp.service.jhgk.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.jhgk.YdjhImportNew;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.mapper.jhgk.YdjhImportNewMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import lombok.AllArgsConstructor;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.support.TransactionTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.function.Consumer;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
public class YdjhImportNewService extends ServiceImpl<YdjhImportNewMapper, YdjhImportNew> {

    private final DmSygdxqMapper sygdxqMapper;
    private final DmBomService bomService;
    private final DmCbxxpService dmCbxxpService;
    private final PgdTzjhService tzjhService;
    private final DmYdjhService dmYdjhService;
    private final TransactionTemplate transactionTemplate;
    private final DmSygdMxService sygdMxService;
    private final RedisTemplate<String, Object> redisTemplate;

    private static final String GJSCGK_SYGDMX_KEY = "GJSCGK::SYGDMX::";
    private static final String GJSCGK_TZJH_KEY = "GJSCGK::TZJH::";
    private static final String GJSCGK_BOM_COUNT_KEY="GJSCGK::BOM::COUNT::";

    public List<String> getFileNameList() {
        return baseMapper.getFileNameList();
    }

    public List<YdjhImportNew> listByFileName(String fileName,String zt) {
        List<YdjhImportNew> list = this.list(Wrappers.<YdjhImportNew>lambdaQuery()
                .eq(StrUtil.isNotEmpty(fileName), YdjhImportNew::get文件名, fileName)
                        .eq(StrUtil.isNotEmpty(zt),YdjhImportNew::getZt,zt)
                .orderByAsc(YdjhImportNew::getId)
        );
        list.stream().filter(item->StrUtil.isNotEmpty(item.getDcPl()))
                .forEach(item->{
                    String dcPl = item.getDcPl();

                    try {
                        dcPl = String.format("%03d", Integer.parseInt(dcPl));
                        item.setDcPl(dcPl);
                    } catch (Exception ignored) {
                    }

                    AtomicInteger 板数 = new AtomicInteger(0);
                    //一垮龙门和一垮数控
                    if (item.get切割完成1() != null) {
                        item.set一垮龙门板数("0");
                        this.getBomSize(item, "7",(size)->{
                            item.set一垮龙门板数(size+"");
                            板数.addAndGet(size);
                        });

                        item.set一垮数控板数("0");
                        this.getBomSize(item, "8",(size)->{
                            item.set一垮数控板数(size+"");
                            板数.addAndGet(size);
                        });
                    }

                    if (item.get切割完成2() != null) {
                        item.set二跨面板板数("0");
                        this.getBomSize(item, "5",(size)->{
                            item.set二跨面板板数(size+"");
                            板数.addAndGet(size);
                        });
                    }

                    if (item.get切割完成3() != null) {
                        AtomicInteger atomicInteger = new AtomicInteger(0);

                        this.getBomSize(item, "9",(size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });

                        this.getBomSize(item, "10",(size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });

                        this.getBomSize(item, "12",(size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });
                        item.set二跨数控板数("0");
                        item.set二跨数控板数(atomicInteger.toString());
                    }

                    if (item.get切割完成4() != null) {
                        item.set三跨平铁板数("0");
                        AtomicInteger atomicInteger = new AtomicInteger(0);
                        this.getBomSize(item, "6",(size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });
                        this.getBomSize(item, "13", (size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });

                        item.set三跨平铁板数(atomicInteger.toString());
                    }

                    if (item.get切割完成5() != null||item.get三跨数控板数()!=null) {
                        item.set三跨数控板数("0");
                        this.getBomSize(item, "14",(size)->{
                            item.set三跨数控板数(size+"");
                            板数.addAndGet(size);
                        });
                    }

                    if (item.get切割完成6() != null) {
                        item.set四区腹板板数("0");
                        this.getBomSize(item, "11",(size)->{
                            item.set四区腹板板数(size+"");
                            板数.addAndGet(size);
                        });
                    }

                    if (item.get切割完成7() != null) {
                        AtomicInteger atomicInteger = new AtomicInteger(0);

                        this.getBomSize(item, "15",(size)->{
                            atomicInteger.addAndGet(size);
                            板数.addAndGet(size);
                        });

                        item.set四区数控板数("0");
                        item.set四区数控板数(atomicInteger.toString());
                    }

//                    if(item.get光电完成()!=null){
//                        this.getBomSize(item, "17", 板数::addAndGet);
//                    }

                    item.set板数(板数.toString());
                });
        return list;
    }

    private void getBomSize(YdjhImportNew item, String kw, Consumer<Integer> handler){
        Integer o = (Integer) redisTemplate.opsForHash().get(GJSCGK_BOM_COUNT_KEY + item.getDcCh(), item.getDcPl() + "_"+kw);
//        if (o==null||o==0){
//            List<DmBom> bomUni = bomService.getBomUni(item.getDcCh(), item.getDcPl(), kw);
//            if (bomUni!=null){
//                o=bomUni.size();
//                redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY + item.getDcCh(), item.getDcPl() + "_"+kw,o);
//            }
//        }
        Optional.ofNullable(o).ifPresent(handler);

    }

    @Transactional(rollbackFor = Exception.class)
    public void sh(String fileName,String shr) {
        LambdaQueryWrapper<YdjhImportNew> wrapper = Wrappers.<YdjhImportNew>lambdaQuery()
                .eq(YdjhImportNew::get文件名, fileName)
                .eq(YdjhImportNew::getZt, YdjhImportNew.ZtEnum.TJ.ordinal());
        String shrq=DateUtil.date().toString("yyyy/MM/dd");
        List<YdjhImportNew> list = this.updateData(wrapper, (item)->{
            item.updateToSh(shr,shrq);
            item.sh();
        });
        if (ObjUtil.isEmpty(list)){
            return;
        }
        List<DmYdjh> updateList=new ArrayList<>();
        list.stream().filter(item->StrUtil.isAllNotEmpty(item.getDcCh(),item.getDcPl()))
                .forEach(item->{
                    String dcPl = item.getDcPl();

                    try {
                        dcPl = String.format("%03d", Integer.parseInt(dcPl));
                    } catch (Exception ignored) {
                    }
                    List<DmYdjh> ydjhList = dmYdjhService.list(Wrappers.<DmYdjh>lambdaQuery()
                            .eq(DmYdjh::getDcCh, item.getDcCh())
                            .eq(DmYdjh::getDcPl, dcPl)
                    );
                    if (ObjUtil.isNotEmpty(ydjhList)){
                        Map<String, List<DmYdjh>> collect = ydjhList.stream()
                                .filter(ydjh->StrUtil.isNotEmpty(ydjh.getKw()))
                                .collect(Collectors.groupingBy(DmYdjh::getKw));
                        //一垮龙门和一垮数控
                        if (item.get切割完成1() != null) {
                            Optional.ofNullable(collect.get("7")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成1());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });

                            Optional.ofNullable(collect.get("8")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成1());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成2() != null) {
                            Optional.ofNullable(collect.get("5")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成2());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成3() != null) {
                            Optional.ofNullable(collect.get("9")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成3());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });

                            Optional.ofNullable(collect.get("10")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成3());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });

                            Optional.ofNullable(collect.get("12")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成3());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成4() != null) {
                            Optional.ofNullable(collect.get("6")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成4());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                            Optional.ofNullable(collect.get("13")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成4());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成5() != null||item.get三跨数控板数()!=null) {
                            Optional.ofNullable(collect.get("14")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成5());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成6() != null) {
                            Optional.ofNullable(collect.get("11")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成6());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }

                        if (item.get切割完成7() != null) {
                            Optional.ofNullable(collect.get("15")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get切割完成7());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });

                            });
                        }

                        if(item.get光电完成()!=null){
                            Optional.ofNullable(collect.get("17")).ifPresent(ydjhs -> {
                                ydjhs.forEach(ydjh->{
                                    DmYdjh dmYdjh = this.updateYdjh(item.get上料完成(),item.get抛丸完成(),item.get光电完成());
                                    dmYdjh.setId(ydjh.getId());
                                    updateList.add(dmYdjh);
                                });
                            });
                        }
                    }
                });

        dmYdjhService.updateBatchById(updateList);
//        redisTemplate.opsForHash().delete(GJSCGK_SYGDMX_KEY+fileName);
//        redisTemplate.opsForHash().delete(GJSCGK_TZJH_KEY+fileName);
    }

    private DmYdjh updateYdjh(String slrq,String pwrq,String qgrq){
        DmYdjh dmYdjh = new DmYdjh();
        dmYdjh.setSljhrq(slrq);
        dmYdjh.setPwjhrq(pwrq);
        dmYdjh.setHxjhrq(qgrq);
        dmYdjh.setQgjhrq(qgrq);
        return dmYdjh;
    }

    public void tj(String fileName) {
        LambdaQueryWrapper<YdjhImportNew> wrapper = Wrappers.<YdjhImportNew>lambdaQuery()
                .eq(YdjhImportNew::get文件名, fileName)
                .eq(YdjhImportNew::getZt, YdjhImportNew.ZtEnum.BZ.ordinal());
        List<YdjhImportNew> list = this.updateData(wrapper, YdjhImportNew::tj);

        List<DmSygdMx> sygdMxList = new ArrayList<>();
        List<PgdTzjh> tzjhList = new ArrayList<>();
        if (ObjUtil.isEmpty(list)){
            return;
        }
        list.stream()
        .filter(item -> !item.getDcPl().contains("-"))//批次范围的数据暂不处理
        .forEach(item -> {
            String dcPl = item.getDcPl();

            try {
                dcPl = String.format("%03d", Integer.parseInt(dcPl));
            } catch (Exception ignored) {
            }
            item.setDcPl(dcPl);
            List<DmSygdMx> sygdmx = (List<DmSygdMx>) redisTemplate.opsForHash().get(GJSCGK_SYGDMX_KEY + fileName, item.getDcCh() + "_" + dcPl);
            if (ObjUtil.isNotEmpty(sygdmx)) {
                sygdMxList.addAll(sygdmx);
            }
            PgdTzjh tzjh = (PgdTzjh) redisTemplate.opsForHash().get(GJSCGK_TZJH_KEY + fileName, item.getDcCh() + "_" + dcPl);
            if (ObjUtil.isNotEmpty(tzjh)){
                tzjhList.add(tzjh);
            }
        });

        if (ObjUtil.isAllEmpty(sygdMxList,tzjhList)){
            return;
        }
        transactionTemplate.execute((status)->{
            list.stream()
                    .filter(item -> !item.getDcPl().contains("-"))//批次范围的数据暂不处理
                    .filter(item -> StrUtil.isAllNotEmpty(item.getDcCh(),item.getDcPl()))
                    .forEach(item->{
                        sygdMxService.remove(new QueryWrapper<DmSygdMx>()
                                .eq("dc_ch", item.getDcCh())
                                .eq("dc_pl", item.getDcPl())
                        );
                        //清理未处理的图纸计划
                        tzjhService.remove(Wrappers.<PgdTzjh>lambdaQuery()
                                .eq(PgdTzjh::getCzbh,item.getDcCh())
                                .eq(PgdTzjh::getPl,item.getDcPl())
                                .and(it->it.isNull(PgdTzjh::getFkrq).or().eq(PgdTzjh::getFkrq,""))
                        );
                    });

            sygdMxService.saveBatch(sygdMxList);

            //图纸计划入库
            tzjhService.saveBatch(tzjhList);
            return true;
        });
    }

    private List<YdjhImportNew> updateData(LambdaQueryWrapper<YdjhImportNew> wrapper, Consumer<YdjhImportNew> handler) {
        List<YdjhImportNew> list = this.list(wrapper);

        list.forEach(item -> {
            YdjhImportNew ydjhImportNew = new YdjhImportNew();
            ydjhImportNew.setId(item.getId());
            ydjhImportNew.setNonBom(item.isNonBom());
            handler.accept(ydjhImportNew);
            this.updateById(ydjhImportNew);
        });
        return list;
    }

    public void handler(List<YdjhImportNew> list, String fileName, HttpServletRequest request) {

        String yhms = (String) request.getAttribute("yhms");
        //三月滚动明细
        this.createSygdmx(list, fileName);

        //没有基础数据的计划生成图纸计划
        this.createTzjh(list, fileName, yhms);

        String date = DateUtil.date().toString("yyyy/MM/dd");
        transactionTemplate.execute((status) -> {
            list.stream()
                    .filter(item -> StrUtil.isAllNotEmpty(item.getDcCh(), item.getDcPl()))
                    .forEach(item -> {
                        item.set文件名(fileName);
                        item.updateToBz(yhms,date);
                        this.remove(new QueryWrapper<YdjhImportNew>()
                                .eq("dc_ch", item.getDcCh())
                                .eq("dc_pl", item.getDcPl())
                                .eq("文件名", fileName)//根据同名文件进行删除
                        );
                    });
            list.forEach(this::save);
            return true;
        });
    }

    private void createTzjh(List<YdjhImportNew> list, String fileName,String yhms) {
        String date = DateUtil.date().toString("yyyy/MM/dd");

        list.stream()
                .filter(item -> !item.getDcPl().contains("-"))//批次范围的数据暂不处理
                .filter(YdjhImportNew::isNonBom)
                .forEach(item -> {
                    String dcPl = item.getDcPl();

                    try {
                        dcPl = String.format("%03d", Integer.parseInt(dcPl));
                    } catch (Exception ignored) {
                    }

                    PgdTzjh dmTzjh = PgdTzjh.of(item, dcPl);
                    dmTzjh.setBzry(yhms);
                    dmTzjh.setBzrq(date);
                    redisTemplate.opsForHash().put(GJSCGK_TZJH_KEY + fileName, item.getDcCh() + "_" + dcPl, dmTzjh);
                });
    }

    /**
     * 月度计划导入,不使用月度计划只能排产功能前提下使用该功能导入月度计划
     */
    private void createSygdmx(List<YdjhImportNew> objList, String fileName) {

        objList.stream()
                .filter(item -> !item.getDcPl().contains("-"))//批次范围的数据暂不处理
                .forEach(item -> {

                    List<DmSygdMx> addList = new ArrayList<>();
                    String dcPl = item.getDcPl();

                    try {
                        dcPl = String.format("%03d", Integer.parseInt(dcPl));
                    } catch (Exception ignored) {
                    }

                    List<DmBom> bomList = bomService.getBomUni(item.getDcCh(), dcPl,null);

                    if (ObjUtil.isEmpty(bomList)) {
                        //无bom,明细数据使用目标船只替代,切在作业计划中生成一条(按照kw进行区分)数据
                        return;
                    }

                    if (ObjUtil.isNotEmpty(bomList)) {
                        item.setNonBom(false);
                    }

                    //修正前方需求数据
                    List<DmSygdxq> dmSygdxqs = sygdxqMapper.selectList(Wrappers.<DmSygdxq>lambdaQuery()
                            .eq(DmSygdxq::getDcCh, item.getDcCh()).eq(DmSygdxq::getDcPl, dcPl));
                    if (ObjUtil.isNotEmpty(dmSygdxqs)) {
                        DmSygdxq dmSygdxq = dmSygdxqs.get(0);
                        item.setQfxqrqxz(dmSygdxq.getXzglxq());
                        item.setQfxqrqdz(dmSygdxq.getDzglxq());
                    }

                    Map<String, List<DmBom>> collect = bomList.stream().collect(Collectors.groupingBy(DmBom::getKw));
                    //一垮龙门和一垮数控
                    String finalDcPl = dcPl;
                    if (item.get切割完成1() != null) {
                        Optional.ofNullable(collect.get("7")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_7",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成1());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

                        Optional.ofNullable(collect.get("8")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_8",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成1());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                    }

                    if (item.get切割完成2() != null) {
                        Optional.ofNullable(collect.get("5")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_5",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成2());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                    }

                    if (item.get切割完成3() != null) {
                        Optional.ofNullable(collect.get("9")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_9",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成3());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

                        Optional.ofNullable(collect.get("10")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_10",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成3());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

                        Optional.ofNullable(collect.get("12")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_12",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成3());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                    }

                    if (item.get切割完成4() != null) {
                        Optional.ofNullable(collect.get("6")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_6",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成4());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                        Optional.ofNullable(collect.get("13")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_13",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成4());
                                dmSygdMx.setQbs("1");
                                dmSygdMx.setQjgrq(item.get曲平铁曲完成());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

                    }

                    if (item.get切割完成5() != null||item.get三跨数控板数()!=null) {
                        Optional.ofNullable(collect.get("14")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_14",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成5());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

//                        Optional.ofNullable(collect.get("13")).ifPresent(boms -> {
//                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_14",boms.size());
//                            boms.forEach(bom -> {
//                                DmSygdMx dmSygdMx = new DmSygdMx();
//                                dmSygdMx.setDcCh(item.getDcCh());
//                                dmSygdMx.setDcPl(item.getDcPl());
//                                dmSygdMx.setQgrq(item.get切割完成5());
//                                dmSygdMx.setQbs("1");
//                                dmSygdMx.setQjgrq(item.get曲外板曲完成());
//                                dmSygdMx.setJssj(item.get小组配送完成());
//                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
//                                dmSygdMx.setBomData(bom);
//                                addList.add(dmSygdMx);
//                            });
//                        });
                    }

                    if (item.get切割完成6() != null) {
                        Optional.ofNullable(collect.get("11")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_11",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成6());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                    }

                    if (item.get切割完成7() != null) {
                        Optional.ofNullable(collect.get("15")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_15",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get切割完成7());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });

                    }

                    if(item.get光电完成()!=null){
                        Optional.ofNullable(collect.get("17")).ifPresent(boms -> {
                            redisTemplate.opsForHash().put(GJSCGK_BOM_COUNT_KEY+item.getDcCh(), finalDcPl +"_17",boms.size());
                            boms.forEach(bom -> {
                                DmSygdMx dmSygdMx = new DmSygdMx();
                                dmSygdMx.setDcCh(item.getDcCh());
                                dmSygdMx.setDcPl(item.getDcPl());
                                dmSygdMx.setQgrq(item.get光电完成());
                                dmSygdMx.setJssj(item.get小组配送完成());
                                dmSygdMx.setGjjsDz(item.getQfxqrqdz());
                                dmSygdMx.setBomData(bom);
                                addList.add(dmSygdMx);
                            });
                        });
                    }

                    redisTemplate.opsForHash().put(GJSCGK_SYGDMX_KEY + fileName, item.getDcCh() + "_" + dcPl, addList);
                });
    }
}
